## juju 0.5.1

=== Makefile ===
PEP8=pep8
COVERAGE_FILES=`find juju -name "*py" | grep -v "tests\|lib/mocker.py\|lib/testing.py"`

all:
	@echo "You've just watched the fastest build on earth."

html:
	make -C docs html
	#@gnome-open docs/build/html/index.html

tests:
	./test

coverage:
	python -c "import coverage as c; c.main()" run ./test
	python -c "import coverage as c; c.main()" html -d htmlcov $(COVERAGE_FILES)
	gnome-open htmlcov/index.html

ftests:
	./test --functional

tags:
	@ctags --python-kinds=-iv -R juju

etags:
	@ctags -e --python-kinds=-iv -R juju

modified=$(shell bzr status -S  |grep -P '^\s*M' | awk '{print $$2;}'| grep -P ".py$$")
check:
	@test -n "$(modified)" && echo $(modified) | xargs $(PEP8) --repeat
	@test -n "$(modified)" && echo $(modified) | xargs pyflakes


modified=$(shell bzr status -S -r ancestor:$(JUJU_TRUNK) |grep -P '^\s*M' | awk '{print $$2;}'| grep -P ".py$$")
review:
	@test -n "$(modified)" && echo $(modified) | xargs $(PEP8) --repeat
	@test -n "$(modified)" && echo $(modified) | xargs pyflakes


modified=$(shell bzr status -S -r branch::prev  |grep -P '^\s*\+?[MN]' | awk '{print $$2;}'| grep -P "test_.*\.py$$")
ptests:
	@test -n "$(modified)" && echo $(modified) | xargs ./test

modified=$(shell  bzr status -S -r ancestor:$(JUJU_TRUNK)/|grep -P 'test.*\.py' |awk '{print $$2;}')
btests:
	@./test $(modified)

.PHONY: tags check review

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = python source/generate_modules.py ../juju source/generated && sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  clean      to clean (remove) everything under the build directory"

clean:
	-rm -rf $(BUILDDIR)/*
	-rm -rf source/generated

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/juju.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/juju.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/juju"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/juju"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

## juju 0.5+bzr398

=== debian/changelog ===
juju (0.5+bzr398-0ubuntu1) oneiric; urgency=low

  * New upstream snapshot.
  * refreshed patches

 -- Clint Byrum <clint@ubuntu.com>  Sun, 09 Oct 2011 09:50:34 -0700

juju (0.5+bzr361-0ubuntu1) oneiric; urgency=low

  * New upstream snapshot. Note upstream rename of project from ensemble
    to juju. Rename upload exception granted by slangasek on IRC.
  * d/p/fix-failing-bundle-test.patch,fix-tests-with-no-ssh-key.patch:
    dropped, merged upstream.
  * d/p/fix-tests-without-aws-access-key-id: refreshed for rename.
  * d/control: change ensemble to meta-package which depends on juju
    so users who have ensemble will have it replaced with juju.
  * d/rules: pull source from lp:juju
  * debian/ensemble: install warning binary for transition.
  * d/p/disable-failing-zookeeper-test.patch: Disable test due to race
    condition in the test (not underlying code), as confirmed upstream.

 -- Clint Byrum <clint@ubuntu.com>  Wed, 28 Sep 2011 09:42:32 -0700

ensemble (0.5+bzr336-0ubuntu1) oneiric; urgency=low

  * New upstream snapshot.
  * d/patches/fix-*: Patches to fix failing tests.
  * d/rules: fail to build if tests fail. Remove test-results.txt
    from package (not as interesting now that they MUST pass).
    (LP: #801020)
  * d/control: Depend on openssh-client. (LP: #835154)

 -- Clint Byrum <clint@ubuntu.com>  Tue, 06 Sep 2011 11:30:15 -0700

ensemble (0.5+bzr306-0ubuntu1) oneiric; urgency=low

  * New upstream snapshot.

 -- Clint Byrum <clint@ubuntu.com>  Wed, 10 Aug 2011 11:59:13 -0500

ensemble (0.5+bzr283-0ubuntu1) oneiric; urgency=low

  * New upstream snapshot.
  * d/control: add build-depends to run test suite
  * d/rules: run test suite but do not fail on it yet

 -- Clint Byrum <clint@ubuntu.com>  Tue, 26 Jul 2011 17:03:36 -0700

ensemble (0.5+bzr274-0ubuntu1) oneiric; urgency=low

  * New upstream snapshot
  * Removing leading article from synopsis to quiet lintian warning.

 -- Clint Byrum <clint@ubuntu.com>  Tue, 12 Jul 2011 16:53:48 -0700

ensemble (0.5+bzr251-0ubuntu1) oneiric; urgency=low

  * Initial Packaging

 -- Clint Byrum <clint@ubuntu.com>  Sun, 12 Jun 2011 20:59:45 -0700

=== debian/control ===
Source: juju
Section: python
Priority: optional
XS-Python-Version: >= 2.5
Maintainer: Juju Developers <juju@lists.ubuntu.com>
Build-Depends: debhelper (>= 7.0.50~), python, 
    zookeeper,
    python-twisted,
    python-txzookeeper (>= 0.2.0),
    python-argparse,
    python-txaws,
    python-yaml,
    python-pydot,
    python-apt
Homepage: https://launchpad.net/juju
Standards-Version: 3.9.1
Vcs-Bzr: https://code.launchpad.net/~juju/juju/packaging

Package: juju
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, python-twisted, python-txzookeeper (>= 0.2.0), python-argparse, python-txaws, python-yaml, openssh-client
Recommends: python-pydot
Provides: ${python:Provides}, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Breaks: ensemble ( <= 0.5+bzr336-0ubuntu1 )
Replaces: ensemble ( <= 0.5+bzr336-0ubuntu1 )
Description: next generation service orchestration system
 Juju is a next generation service orchestration framework. It has been
 likened to APT for the cloud. With Juju, different authors are able to
 create service formulas, called charms, independently, and make those
 services coordinate their communication and configuration through a
 simple protocol.

Package: ensemble
Architecture: all
Depends: juju
Description: transition package for rename to juju
 Ensemble has been renamed to Juju
 .
 Juju is a next generation service orchestration framework. It has been
 likened to APT for the cloud. With Juju, different authors are able to
 create service formulas, called charms, independently, and make those
 services coordinate their communication and configuration through a
 simple protocol.

=== debian/rules ===
#!/usr/bin/make -f

REV=$(shell dpkg-parsechangelog | sed -rne 's,^Version: .*[+~]bzr([0-9]+).*,\1,p')
VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')

%:
	dh $@ --buildsystem=python_distutils --with python2

override_dh_auto_test:
	./test

get-orig-source:
	bzr export -r $(REV) --root=ensemble=$(VER).orig \
               ensemble_$(VER).orig.tar.gz lp:juju

override_dh_clean:
	dh_clean

## juju 0.5+bzr531

=== debian/changelog ===
juju (0.5+bzr531-0ubuntu1.3) precise-security; urgency=low

  * SECURITY UPDATE: d/p/upstream-543.patch: Disable password authentication
    on LXC containers created in the local provider. (LP: #1016428)
  * SECURITY UPDATE: d/p/upstream-564.patch: Fix example mysql charm to
    not expose root mysql password to all users. (LP: #1040165)
  * SECURITY UPDATE: d/p/upstream-565.patch: Verify charm store hostname
    matches hostname on SSL certificate. (LP: #992447)

 -- Clint Byrum <clint@ubuntu.com>  Thu, 23 Aug 2012 17:12:26 -0700

juju (0.5+bzr531-0ubuntu1.2) precise-proposed; urgency=low

  * d/p/upstream-541-542.patch: fix shell script to make proposed work
    for local provider. (LP: #1007657)

 -- Clint Byrum <clint@ubuntu.com>  Mon, 18 Jun 2012 14:00:56 -0700

juju (0.5+bzr531-0ubuntu1.1) precise-proposed; urgency=low

  * d/p/upstream-532.patch: use proper whitespace separation in
    relation-ids. (LP: #988065)
  * d/p/upstream-533.patch: workaround to suppress Zookeeper logging
    which goes out of control in local provider on Reboot.(LP: #958312)
  * d/p/upstream-534.patch: fix to stop juju-log and relation-set commands
    outputting "{}" to stdout, which can break some programs and makes it
    difficult to use them in a debug-hooks session. (LP: #915506)
  * d/p/upstream-537.patch: make HTTPS apt sources usable inside local
    provider. (LP: #993034)
  * d/p/upstream-538.patch: Add support to install juju from proposed
    pocket to test proposed SRU's. (LP: #926550)

 -- Clint Byrum <clint@ubuntu.com>  Tue, 29 May 2012 22:56:16 -0700

juju (0.5+bzr531-0ubuntu1) precise; urgency=low

  * New upstream snapshot (LP: #985249)
  * d/p/fix-tests-without-aws-key.patch: Dropped as it has been
    superseded by a better upstream fix (LP: #819329)
  * d/p/no-write-sample-on-help.patch: Dropped, Applied upstream.
  * d/p/disable-failing-zookeeper-test.patch refreshed.
  * d/control: new code requires latest txzookeeper upstream.

 -- Clint Byrum <clint@ubuntu.com>  Wed, 18 Apr 2012 15:45:34 -0700

juju (0.5+bzr504-0ubuntu1) precise; urgency=low

  * New upstream snapshot (LP: #962507 LP: #953258 LP: #965507).
  * d/control: Depend and Build-Depend on python-oauth for MaaS.
  * d/control: Drop dummy ensemble package and make breaks/replaces
    broader to force removal of any ensemble package. (LP: #954492)
  * d/control: Move lxc, libvirt-bin, and zookeeper to Suggests to
    reduce the amount of packages installed on every node unecessarily
    and also avoid conflicting when deploying into a libvirt-bin
    default network VM (LP: #962389)
  * d/rules: skip test suite when nocheck is set.
  * d/rules: remove redundant dh_clean call
  * d/juju.install: remove usr, with only one binary package this is
    not necessary anymore and causes dh_install to fail because no
    files are installed to debian/tmp anymore.
  * d/rules,d/control,d/manpages,d/juju.manpages: Generate basic
    manpage from online help. (LP: #966611)
  * d/patches/no-write-sample-on-help.patch: Added so --help can be
    safely run without a writable home dir on buildds. (LP: #957682)

 -- Clint Byrum <clint@ubuntu.com>  Fri, 30 Mar 2012 15:28:16 -0700

juju (0.5+bzr457-0ubuntu1) precise; urgency=low

  * New upstream snapshot.

 -- Clint Byrum <clint@ubuntu.com>  Thu, 16 Feb 2012 03:44:02 -0800

juju (0.5+bzr447-0ubuntu1) precise; urgency=low

  * d/control: Recommend components necessary for local provider except
    apt-cacher-ng, which is suggested. (LP: #873540) Also depend on tmux
    for debug-hooks and recommend byobu so the branding will be the same.
  * d/control: removing inaccurate Vcs-Bzr.
  * New upstream snapshot.
    - Fixed regression with twisted 11.1 (LP: #917954)

 -- Clint Byrum <clint@ubuntu.com>  Mon, 23 Jan 2012 10:16:55 -0800

juju (0.5+bzr424-0ubuntu1) precise; urgency=low

  * New upstream snapshot.
  * d/control: No longer build-dep or depend on python-argparse, as
    it seems to cause fits with pkg_resources.

 -- Clint Byrum <clint@ubuntu.com>  Thu, 01 Dec 2011 13:15:51 -0800

=== debian/control ===
Source: juju
Section: python
Priority: optional
XS-Python-Version: >= 2.5
Maintainer: Juju Developers <juju@lists.ubuntu.com>
Build-Depends: debhelper (>= 7.0.50~), python, 
    zookeeper,
    python-twisted,
    python-txzookeeper (>= 0.9.5~),
    python-txaws,
    python-yaml,
    python-pydot,
    python-apt,
    python-oauth,
    help2man
Homepage: https://launchpad.net/juju
Standards-Version: 3.9.1

Package: juju
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, python-twisted, python-txzookeeper (>= 0.9.5~), python-txaws, python-yaml, openssh-client, tmux, python-oauth
Recommends: python-pydot, byobu
Suggests: apt-cacher-ng, lxc, libvirt-bin, zookeeper
Provides: ${python:Provides}, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Breaks: ensemble
Replaces: ensemble
Description: next generation service orchestration system
 Juju is a next generation service orchestration framework. It has been
 likened to APT for the cloud. With Juju, different authors are able to
 create service formulas, called charms, independently, and make those
 services coordinate their communication and configuration through a
 simple protocol.

=== debian/rules ===
--- 
+++ 
@@ -7,11 +7,34 @@
 	dh $@ --buildsystem=python_distutils --with python2
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	./test
+endif
 
 get-orig-source:
 	bzr export -r $(REV) --root=ensemble=$(VER).orig \
-               ensemble_$(VER).orig.tar.gz lp:juju
+               juju_$(VER).orig.tar.gz lp:juju
 
-override_dh_clean:
-	dh_clean
+override_dh_auto_clean::
+	rm -f debian/manpages/*.partial
+	rm -f debian/manpages/*.1
+
+override_dh_auto_build:: debian/manpages/juju.1
+
+HELP2MAN=PYTHONPATH=`pwd` help2man -N --version-string $(VER)
+
+debian/manpages/juju.1:
+	$(HELP2MAN) --name "juju service orchestration system admin client" \
+     --include debian/manpages/juju.includes.in bin/juju \
+     > debian/manpages/juju.1.partial
+	$(HELP2MAN) --name "juju bootstrap tool" \
+     --include debian/manpages/juju-admin.in bin/juju-admin \
+     > debian/manpages/juju-admin.1.partial
+	for i in `ls bin|grep -v juju` ; do \
+        $(HELP2MAN) --name "Juju charm API commands" \
+         --include debian/manpages/charm_api.in \
+         bin/$$i > debian/manpages/$$i.1.partial ;\
+         mv debian/manpages/$$i.1.partial debian/manpages/$$i.1 ;\
+    done
+	mv -f debian/manpages/juju-admin.1.partial debian/manpages/juju-admin.1
+	mv -f debian/manpages/juju.1.partial debian/manpages/juju.1

## juju 0.5.1

=== debian/changelog ===
juju (0.5.1-3) unstable; urgency=low

  * Disable test suite build to address FTBFS issues (Closes: #702791)

 -- Clint Byrum <clint@ubuntu.com>  Fri, 22 Mar 2013 11:11:54 -0700

juju (0.5.1-2) unstable; urgency=high

  * SECURITY UPDATE: d/p/upstream-565.patch: Verify charm store hostname
    matches hostname on SSL certificate. (Closes: #685728)
  * d/p/upstream-566.patch: Fix test suite failure causing FTBFS with
    python 2.7.3.

 -- Clint Byrum <spamaps@debian.org>  Thu, 23 Aug 2012 17:41:25 -0700

juju (0.5.1-1) unstable; urgency=low

  * New upstream release

 -- Clint Byrum <spamaps@debian.org>  Sat, 30 Jun 2012 06:58:12 -0700

juju (0.5+bzr542-1) unstable; urgency=low

  * New upstream snapshot

 -- Clint Byrum <spamaps@debian.org>  Mon, 18 Jun 2012 12:10:19 -0700

juju (0.5+bzr541-1) unstable; urgency=low

  * New upstream snapshot

 -- Clint Byrum <spamaps@debian.org>  Sun, 17 Jun 2012 15:39:48 -0700

juju (0.5+bzr539-1) unstable; urgency=low

  * Initial Packaging (Closes: #629857)

 -- Clint Byrum <spamaps@debian.org>  Mon, 11 Jun 2012 15:40:48 -0700

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: juju
-Section: python
+Section: net
 Priority: optional
 XS-Python-Version: >= 2.5
-Maintainer: Juju Developers <juju@lists.ubuntu.com>
-Build-Depends: debhelper (>= 7.0.50~), python, 
+Maintainer: Clint Byrum <spamaps@debian.org>
+Build-Depends: debhelper (>= 7.0.50~), python (>= 2.6.6-3~),
     zookeeper,
     python-twisted,
     python-txzookeeper (>= 0.9.5~),
@@ -12,9 +12,10 @@
     python-pydot,
     python-apt,
     python-oauth,
-    help2man
+    help2man,
+    lsb-release
 Homepage: https://launchpad.net/juju
-Standards-Version: 3.9.1
+Standards-Version: 3.9.3
 
 Package: juju
 Architecture: all
@@ -23,8 +24,6 @@
 Suggests: apt-cacher-ng, lxc, libvirt-bin, zookeeper
 Provides: ${python:Provides}, ${misc:Depends}
 XB-Python-Version: ${python:Versions}
-Breaks: ensemble
-Replaces: ensemble
 Description: next generation service orchestration system
  Juju is a next generation service orchestration framework. It has been
  likened to APT for the cloud. With Juju, different authors are able to

=== debian/rules ===
--- 
+++ 
@@ -6,13 +6,13 @@
 %:
 	dh $@ --buildsystem=python_distutils --with python2
 
-override_dh_auto_test:
-ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	./test
-endif
+#override_dh_auto_test:
+#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+#	./test
+#endif
 
 get-orig-source:
-	bzr export -r $(REV) --root=ensemble=$(VER).orig \
+	bzr export -r $(REV) --root=juju-$(VER).orig \
                juju_$(VER).orig.tar.gz lp:juju
 
 override_dh_auto_clean::
@@ -30,7 +30,7 @@
 	$(HELP2MAN) --name "juju bootstrap tool" \
      --include debian/manpages/juju-admin.in bin/juju-admin \
      > debian/manpages/juju-admin.1.partial
-	for i in `ls bin|grep -v juju` ; do \
+	for i in `ls bin|grep -v juju$$|grep -v juju-admin$$` ; do \
         $(HELP2MAN) --name "Juju charm API commands" \
          --include debian/manpages/charm_api.in \
          bin/$$i > debian/manpages/$$i.1.partial ;\

## juju 0.6

=== Makefile ===
--- 
+++ 
@@ -3,10 +3,6 @@
 
 all:
 	@echo "You've just watched the fastest build on earth."
-
-html:
-	make -C docs html
-	#@gnome-open docs/build/html/index.html
 
 tests:
 	./test
@@ -33,7 +29,7 @@
 
 modified=$(shell bzr status -S -r ancestor:$(JUJU_TRUNK) |grep -P '^\s*M' | awk '{print $$2;}'| grep -P ".py$$")
 review:
-	@test -n "$(modified)" && echo $(modified) | xargs $(PEP8) --repeat
+	#@test -n "$(modified)" && echo $(modified) | xargs $(PEP8) --repeat
 	@test -n "$(modified)" && echo $(modified) | xargs pyflakes

=== debian/changelog ===
juju (0.6-1ubuntu1) quantal; urgency=low

  * d/patches/maas-tag-conversion.patch: Fix maas provider api usage
    of maas-tags constraint. (LP: #1064734)

 -- Martin Packman <martin.packman@canonical.com>  Wed, 10 Oct 2012 14:41:08 +0000

juju (0.6-1) experimental; urgency=low

  * New upstream release
  * d/control: Removing libvirt-bin from Suggests as it is no longer
    needed.

 -- Clint Byrum <spamaps@debian.org>  Tue, 09 Oct 2012 12:35:35 -0700

juju (0.5.99+bzr585-1) experimental; urgency=low

  * New upstream snapshot.

 -- Clint Byrum <spamaps@debian.org>  Tue, 02 Oct 2012 13:05:17 -0700

juju (0.5.1+bzr566-1) experimental; urgency=low

  * New upstream release
  * d/control: build-dep and dep on procps because "kill" is called
    in juju.lib.service

 -- Clint Byrum <spamaps@debian.org>  Fri, 24 Aug 2012 16:02:42 -0700

juju (0.5.1+bzr559-1) experimental; urgency=low

  * New upstream snapshot
  * Use new environment variable to raise test timeout since
    5s may be too low on some buidlds. (LP: #1026714)

 -- Clint Byrum <spamaps@debian.org>  Thu, 19 Jul 2012 11:01:09 -0700

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Section: net
 Priority: optional
 XS-Python-Version: >= 2.5
-Maintainer: Clint Byrum <spamaps@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Clint Byrum <spamaps@debian.org>
 Build-Depends: debhelper (>= 7.0.50~), python (>= 2.6.6-3~),
     zookeeper,
     python-twisted,
@@ -13,15 +14,16 @@
     python-apt,
     python-oauth,
     help2man,
-    lsb-release
+    lsb-release,
+    procps
 Homepage: https://launchpad.net/juju
 Standards-Version: 3.9.3
 
 Package: juju
 Architecture: all
-Depends: ${python:Depends}, ${misc:Depends}, python-twisted, python-txzookeeper (>= 0.9.5~), python-txaws, python-yaml, openssh-client, tmux, python-oauth
+Depends: ${python:Depends}, ${misc:Depends}, python-twisted, python-txzookeeper (>= 0.9.5~), python-txaws, python-yaml, openssh-client, tmux, python-oauth, procps
 Recommends: python-pydot, byobu
-Suggests: apt-cacher-ng, lxc, libvirt-bin, zookeeper
+Suggests: apt-cacher-ng, lxc, zookeeper
 Provides: ${python:Provides}, ${misc:Depends}
 XB-Python-Version: ${python:Versions}
 Description: next generation service orchestration system

=== debian/rules ===
--- 
+++ 
@@ -6,10 +6,10 @@
 %:
 	dh $@ --buildsystem=python_distutils --with python2
 
-#override_dh_auto_test:
-#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-#	./test
-#endif
+override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	JUJU_TEST_TIMEOUT=30 ./test
+endif
 
 get-orig-source:
 	bzr export -r $(REV) --root=juju-$(VER).orig \

## juju 0.7

=== Makefile ===
PEP8=pep8
COVERAGE_FILES=`find juju -name "*py" | grep -v "tests\|lib/mocker.py\|lib/testing.py"`

all:
	@echo "You've just watched the fastest build on earth."

tests:
	./test

coverage:
	python -c "import coverage as c; c.main()" run ./test
	python -c "import coverage as c; c.main()" html -d htmlcov $(COVERAGE_FILES)
	gnome-open htmlcov/index.html

ftests:
	./test --functional

tags:
	@ctags --python-kinds=-iv -R juju

etags:
	@ctags -e --python-kinds=-iv -R juju


present_pep8=$(shell which $(PEP8))
present_pyflakes=$(shell which pyflakes)
warn_missing_linters:
	@test -n "$(present_pep8)" || echo "WARNING: $(PEP8) not installed."
	@test -n "$(present_pyflakes)" || echo "WARNING: pyflakes not installed."


# "check": Check uncommitted changes for lint.
check_changes=$(shell bzr status -S | grep '^[ +]*[MN]' | awk '{print $$2;}' | grep "\\.py$$")
check: warn_missing_linters
	@test -z $(present_pep8) || (echo $(check_changes) | xargs -r $(PEP8) --repeat)
	@test -z $(present_pyflakes) || (echo $(check_changes) | xargs -r pyflakes)


# "review": Check all changes compared to trunk for lint.
review_changes=$(shell bzr status -S -r ancestor:$(JUJU_TRUNK) | grep '^[ +]*[MN]' | awk '{print $$2;}' | grep "\\.py$$")
review: warn_missing_linters
	#@test -z $(present_pep8) || (echo $(review_changes) | xargs -r $(PEP8) --repeat)
	@test -z $(present_pyflakes) || (echo $(review_changes) | xargs -r pyflakes)


ptests_changes=$(shell bzr status -S -r branch::prev | grep -P '^[ +]*[MN]' | awk '{print $$2;}'| grep "test_.*\\.py$$")
ptests:
	@echo $(ptests_changes) | xargs -r ./test

btests_changes=$(shell bzr status -S -r ancestor:$(JUJU_TRUNK)/ | grep "test.*\\.py$$" | awk '{print $$2;}')
btests:
	@./test $(btests_changes)

.PHONY: tags check review warn_missing_linters

=== debian/changelog ===
juju (0.7-0ubuntu2) saucy; urgency=low

  * Re-introduce juju 0.7 package to saucy to support use with pre
    juju 1.11 environments (LP: #1200878):
    - d/control: Drop juju package; this is now owned by juju-core.
  * d/patches/juju-0.7-head.patch: Resync 0.7 release with head of
    upstream 0.7 branch.
  * d/patches/workaround-lxc-python-env.patch: Dropped, included in
    resync with upstream 0.7 branch.
  * d/rules,juju.docs->juju.docs.in: Put documentation into the juju-0.7
    package.

 -- James Page <james.page@ubuntu.com>  Fri, 23 Aug 2013 12:07:03 +0100

juju (0.7-0ubuntu1) raring; urgency=low

  [ Clint Byrum ]
  * d/p/fix-tests-do-not-use-etc-lsb-release: Dropped, patch applied upstream.
  * d/p/maas-tag-conversion.patch: Dropped, patch applied upstream.
  * d/juju.docs: Remove examples as they have been dropped upstream.

  [ Mark Mims ]
  * Add postinst and prerm scripts using update-alternatives to install into
    a versioned location, enabling co-installability with the go juju port.

  [ Martin Packman ]
  * New upstream release. (lp: #1167921)
  * d/p/workaround-lxc-python-env.patch: Workaround regression with local
    provider failing with SyntaxError on running lxc scripts when user has
    Python 3 specific environment variables set. (lp: #1130809)

 -- Martin Packman <martin.packman@canonical.com>  Wed, 10 Apr 2013 13:57:21 +0000

=== debian/control ===
--- 
+++ 
@@ -17,11 +17,13 @@
     lsb-release,
     procps
 Homepage: https://launchpad.net/juju
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 
-Package: juju
+Package: juju-0.7
 Architecture: all
 Depends: ${python:Depends}, ${misc:Depends}, python-twisted, python-txzookeeper (>= 0.9.5~), python-txaws, python-yaml, openssh-client, tmux, python-oauth, procps
+Breaks: juju (<< 0.7-0ubuntu1~)
+Replaces: juju (<< 0.7-0ubuntu1~)
 Recommends: python-pydot, byobu
 Suggests: apt-cacher-ng, lxc, zookeeper
 Provides: ${python:Provides}, ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f

REV=$(shell dpkg-parsechangelog | sed -rne 's,^Version: .*[+~]bzr([0-9]+).*,\1,p')
VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')
MAJOR_VER=0.7
ifeq "$(REV)" ""
	REV=tag:$(VER)
endif
MANDIR=debian/manpages

%:
	dh $@ --with python2

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	JUJU_TEST_TIMEOUT=30 ./test
endif

get-orig-source:
	bzr export -r $(REV) --root=juju-$(VER).orig \
               juju_$(VER).orig.tar.gz lp:juju/$(MAJOR_VER)

override_dh_auto_clean::
	rm -f debian/manpages/*.partial
	rm -f debian/manpages/*.1
	rm -f debian/juju-$(VER).postinst debian/juju-$(VER).docs debian/juju-$(VER).prerm

HELP2MAN=PYTHONPATH=`pwd` help2man -N --version-string $(VER)

generate_juju_manpages:
	mkdir -p $(MANDIR)
	$(HELP2MAN) --name "juju service orchestration system admin client" \
     --include debian/manpages/juju.includes.in bin/juju \
     > debian/manpages/juju.1.partial
	$(HELP2MAN) --name "juju bootstrap tool" \
     --include debian/manpages/juju-admin.in bin/juju-admin \
     > debian/manpages/juju-admin.1.partial
	for i in `ls bin|grep -v juju$$|grep -v juju-admin$$` ; do \
        $(HELP2MAN) --name "Juju charm API commands" \
         --include debian/manpages/charm_api.in \
         bin/$$i > debian/manpages/$$i.1.partial ;\
         mv debian/manpages/$$i.1.partial $(MANDIR)/$$i.1 ;\
    done
	mv -f debian/manpages/juju-admin.1.partial $(MANDIR)/juju-admin.1
	mv -f debian/manpages/juju.1.partial $(MANDIR)/juju.1

override_dh_auto_build: generate_juju_manpages

install_juju_manpages:
	mkdir -p debian/juju-$(MAJOR_VER)/usr/lib/juju-$(VER)/man/man1
	cp -a debian/manpages/*.1 debian/juju-$(MAJOR_VER)/usr/lib/juju-$(VER)/man/man1/
	gzip debian/juju-$(MAJOR_VER)/usr/lib/juju-$(VER)/man/man1/*.1

install_bash_completion:
	mkdir -p debian/juju-$(MAJOR_VER)/usr/lib/juju-$(VER)/etc/bash_completion.d
	cp -a misc/bash_completion.d/juju debian/juju-$(MAJOR_VER)/usr/lib/juju-$(VER)/etc/bash_completion.d/juju

debian/juju-$(VER).docs: debian/juju.docs.in
	sed -e "s/__NEW_VERSION__/$(VER)/g" $< > $@

override_dh_auto_install: install_juju_manpages install_bash_completion debian/juju-$(VER).docs
	set -e && python setup.py install --root=debian/juju-$(MAJOR_VER) --install-layout=deb --install-scripts=/usr/lib/juju-$(VER)/bin --compile
	dh_auto_install

debian/juju-$(VER).postinst: debian/juju.postinst.in
	sed -e "s/__NEW_VERSION__/$(VER)/g" $< > $@

debian/juju-$(VER).prerm: debian/juju.prerm.in
	sed -e "s/__NEW_VERSION__/$(VER)/g" $< > $@

override_dh_installdeb: debian/juju-$(VER).postinst debian/juju-$(VER).prerm
	dh_installdeb
